  11 REM Machine Code Calculator
         part 1 of 5
      by Toni Baker
    from ZX Computing, Jul'86
  12 REM Modified to include
         hex conversion
       & STK_DATA format  [JimG]

 100 DEF FN h$(n)=CHR$ (INT n+48+(7 AND INT n>9))
1000 REM number to FP
1010 DIM b$(5,2)
1015 GO SUB 1020: GO TO 1015

1020 REM called from 1015 & 3015
1021 INPUT "number ";x: PRINT x;TAB 9;"= ";
1030 IF ABS x>65535 OR x<>INT x THEN GO TO 1120
1050 DIM b(5)
1060 IF x<0 THEN LET b(2)=255: LET x=x+65536
1080 LET b(4)=INT (x/256): LET b(3)=x-256*b(4)
1110 GO TO 1305

1120 DIM B(5): LET exponent=1+INT (LN ABS x/LN 2)
1130 IF exponent<-127 THEN LET x=0: GO TO 1050
1140 LET mantissa=ABS x/2^exponent: LET b(1)=exponent+128: LET a=mantissa
1170 FOR i=2 TO 5: LET a=256*a: LET b(i)=INT a: LET a=a-b(i): NEXT i
1220 LET c=(a>=.5)
1230 FOR i=5 TO 2 STEP -1
1250   LET b(i)=b(i)+c: LET c=(b(i)=256): LET b(i)=b(i) AND NOT c
1270 NEXT i
1280 IF c THEN LET b(2)=128: LET b(1)=b(1)+1
1300 IF x>0 THEN LET b(2)=b(2)-128
1305 GO SUB 1310: GO SUB 1400: RETURN

1310 FOR i=1 TO 5: PRINT b(i);TAB i*4+11;: NEXT i:
     PRINT TAB 11;: RETURN

1400 FOR i=1 TO 5:
       LET num=b(i): GO SUB 1500: LET b$(i)=n$: PRINT n$;TAB i*4+11;:
     NEXT i: PRINT: RETURN

1500 LET hi=INT (num/16): LET lo=num-hi*16: LET n$=FN h$(hi)+FN h$(lo):
     RETURN


2000 REM FP to number
2001 DEF FN i(n)=CODE n$(n)-48-(7 AND n$(n)>="A")
2005 PRINT "'H' prefix for xx hex byte": POKE 23658,8:
     DIM b(5): DIM b$(5,2): RESTORE 2015: LET p=PEEK 23639+256*PEEK 23640+6:
     IF PEEK (p+2)<>CODE "b" THEN STOP

2010 PRINT AT 21,0'
2011 FOR i=1 TO 5:
       POKE p,CODE "AEDCB"(i): INPUT (CHR$ PEEK p);" "; LINE n$
2012   IF CODE n$<>CODE "H" THEN
         LET b(i)=VAL n$
2013   IF CODE n$ =CODE "H" THEN
         LET n$="00"( TO 3-LEN n$)+n$(2 TO): LET b(i)=FN i(1)*16+FN i(2)
2015   LET A=b(i)
2016   PRINT CHR$ PEEK p;"=";b(i);" ";:
     NEXT i
2020 PRINT TAB 11;: GO SUB 1310: GO SUB 1400
2030 IF NOT a THEN
       LET number=256*c+d-(65536 AND e=255): GO TO 2130
2070 LET exponent=a-128
2080 LET sign=-1 OR e<128
2100 LET e=e+(128 AND e<128)
2110 LET mantissa=e/256+d/65536+c/16777216+b/4294967296
2120 LET number=sign*2^exponent*mantissa
2130 PRINT TAB 9;"= ";number
2140 GO TO 2010


3000 REM STK_DATA byte format
3001 DIM b$(5,2)
3015 GO SUB 1020: LET aa=b(1): LET a$=b$(1): LET f$="34-": LET s$="":
     FOR i=1 TO 5: LET s$=s$+b$(i): NEXT i:
     IF a$>="51" AND a$<="8F" THEN GO TO 3100
3020 LET num=aa-80+(256 AND aa<80): GO SUB 1500:
     IF b$(3)="00" AND b$(4)="00" AND b$(5)="00" THEN
       LET f$=f$+"00-"+n$+"-"+b$(2): GO TO 3200
3030 IF b$(4)="00" AND b$(5)="00" THEN
       LET f$=f$+"40-"+n$+"-"+b$(2)+"-"+b$(3): GO TO 3200
3040 IF b$(5)="00" THEN
       LET f$=f$+"80-"+n$+"-"+b$(2)+"-"+b$(3)+"-"+b$(4): GO TO 3200
3050 LET f$=f$+"C0-"+n$+"-"+b$(2)+"-"+b$(3)+"-"+b$(4)+"-"+b$(5): GO TO 3200
3120 LET num=aa-80: GO SUB 1500:
     IF b$(3)="00" AND b$(4)="00" AND b$(5)="00" THEN
       LET f$=f$+n$+"-"+b$(2): GO TO 3200
3130 LET num=aa-16: GO SUB 1500:
     IF b$(4)="00" AND b$(5)="00" THEN
       LET f$=f$+n$+"-"+b$(2)+"-"+b$(3): GO TO 3200
3140 LET num=aa+48: GO SUB 1500:
     IF b$(5)="00" THEN
       LET f$=f$+n$+"-"+b$(2)+"-"+b$(3)+"-"+b$(4):
GO TO 3200
3150 LET num=aa+112: GO SUB 1500:
     LET f$=f$+n$+"-"+b$(2)+"-"+b$(3)+"-"+b$(4)+"-"+b$(5)
3200 PRINT "stacks as: ";f$:
    GO TO 3015